## ros-indigo-dataspeed-can-usb 1.0.12

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(dataspeed_can_usb)

find_package(catkin REQUIRED COMPONENTS
  roslib
  roscpp
  nodelet
  can_msgs
  std_msgs
  lusb
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "Enabling coverage testing")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
endif()

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME}
  src/nodelet.cpp
  src/CanUsb.cpp
  src/CanDriver.cpp
)
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
)

add_executable(can_node
  src/node.cpp
)
target_link_libraries(can_node
  ${catkin_LIBRARIES}
  ${PROJECT_NAME}
)

install(TARGETS ${PROJECT_NAME} can_node
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)
install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)
install(FILES nodelets.xml
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(DIRECTORY firmware launch
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(DIRECTORY scripts
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        USE_SOURCE_PERMISSIONS
)

if(CATKIN_BUILD_BINARY_PACKAGE)
  # Install udev rules with dh_installudev: http://manpages.ubuntu.com/manpages/man1/dh_installudev.1.html
  FILE(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/debian/udev)
  FILE(GLOB UDEV_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/udev" "${CMAKE_CURRENT_SOURCE_DIR}/udev/*.rules")
  FOREACH(FILENAME ${UDEV_FILES})
    MESSAGE(STATUS "Appending contents of udev/${FILENAME} to debian/udev")
    FILE(READ udev/${FILENAME} FILEDATA)
    FILE(APPEND ${CMAKE_CURRENT_SOURCE_DIR}/debian/udev ${FILEDATA})
  ENDFOREACH(FILENAME)

  # ROS Indigo/Jade on Ubuntu versions earlier than Xenial default to a udev priority of 40, which is not enough to override the default usb rule of priority 50
  # http://manpages.ubuntu.com/manpages/trusty/man1/dh_installudev.1.html
  # For ROS versions earlier than Kinetic, install duplicate rule of priority 59
  STRING(REPLACE "_" "-" DEBIAN_PACKAGE_NAME ros-$ENV{ROS_DISTRO}-${PROJECT_NAME})
  if($ENV{ROS_DISTRO} STRLESS kinetic)
    install(FILES debian/udev
            DESTINATION /lib/udev/rules.d
            RENAME 59-${DEBIAN_PACKAGE_NAME}.rules
    )
  endif()
else()
  install(DIRECTORY udev
          DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  )
endif()

if (CATKIN_ENABLE_TESTING)
  add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
### Unit tests
#
#   Only configured when CATKIN_ENABLE_TESTING is true.

# These dependencies are only needed for unit testing
find_package(roslaunch REQUIRED)

# Check all the launch/*.launch files
roslaunch_add_file_check(../launch)

# C++ gtests
catkin_add_gtest(${PROJECT_NAME}_test_mac_addr test_mac_addr.cpp)
catkin_add_gtest(${PROJECT_NAME}_test_module_version test_module_version.cpp)

=== debian/changelog ===
ros-indigo-dataspeed-can-usb (1.0.12-0trusty) trusty; urgency=high

  * Added tcpNoDelay() for subscribers
  * Added firmware version publisher
  * Contributors: Kevin Hallenbeck, Lincoln Lorenz

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 19 Dec 2018 05:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.11-0trusty) trusty; urgency=high

  * Added option to connect to a specific USB device by MAC address
  * Added normal/listen-only mode options
  * Only subscribe to can_tx in normal mode, listen-only mode cannot transmit
  * Updated module firmware to 10.4.0
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 06 Sep 2018 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.10-0trusty) trusty; urgency=high



 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 13 Jun 2018 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.9-0trusty) trusty; urgency=high

  * Removed the private dataspeed_boot_usb package as an exec dependency
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Tue, 12 Jun 2018 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.8-0trusty) trusty; urgency=high

  * Detect old firmware versions and recommend update script
  * Added script to update module firmware
  * Updated module firmware to 10.3.0
  * Added build dependency on roslib, needed for the ROS_DISTRO environment variable
  * Use the simple filename 'udev' when installing rules, instead of the debian package name
  * Added roslaunch test
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Mon, 09 Apr 2018 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.7-0trusty) trusty; urgency=high

  * Added missing roslaunch dependency
  * Added support for CAN error frames
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 19 Oct 2017 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.6-0trusty) trusty; urgency=high

  * Only warn about dropped messages when the drop count changes
  * Migrated from dataspeed_can_msgs to can_msgs (this will break dependent packages)
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 07 Sep 2017 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.5-0trusty) trusty; urgency=high

  * Prioritize the local include folder (there were issues with catkin workspace overlays)
  * Updated nodelets to the PLUGINLIB_EXPORT_CLASS macro
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Mon, 21 Aug 2017 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.4-0trusty) trusty; urgency=high

  * Priority fix for udev on Indigo
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Mon, 08 May 2017 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.3-0trusty) trusty; urgency=high

  * Install udev rules with dh_installudev
  * Updated package.xml format to version 2
  * Fixed copy paste error in example launch file
  * Contributors: Kevin Hallenbeck, Lincoln Lorenz

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Tue, 25 Apr 2017 04:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.2-0trusty) trusty; urgency=high

  * Throttle the 'not found' warning to every 10 seconds
  * Install headers for use by other packages
  * Option to specify USB device in constructor, option to specify textual name
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Tue, 24 Jan 2017 05:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.1-0trusty) trusty; urgency=high

  * Added example launch file
  * Contributors: Kevin Hallenbeck

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Thu, 17 Nov 2016 05:00:00 -0000

ros-indigo-dataspeed-can-usb (1.0.0-0trusty) trusty; urgency=high

  * Initial release
  * Contributors: Kevin Hallenbeck, Michael Lohrer

 -- Kevin Hallenbeck <khallenbeck@dataspeedinc.com>  Wed, 28 Sep 2016 04:00:00 -0000

=== debian/control ===
Source: ros-indigo-dataspeed-can-usb
Section: misc
Priority: extra
Maintainer: Kevin Hallenbeck <khallenbeck@dataspeedinc.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-can-msgs, ros-indigo-catkin, ros-indigo-lusb, ros-indigo-nodelet, ros-indigo-roscpp, ros-indigo-roslaunch, ros-indigo-roslib, ros-indigo-std-msgs
Homepage: http://dataspeedinc.com
Standards-Version: 3.9.2

Package: ros-indigo-dataspeed-can-usb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-can-msgs, ros-indigo-lusb, ros-indigo-nodelet, ros-indigo-roscpp, ros-indigo-roslaunch, ros-indigo-std-msgs
Description: Driver to interface with the Dataspeed Inc.
 USB CAN Tool

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-dataspeed-can-usb//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
